from PyObjCTools.TestSupport import *
import objc

from AppKit import *

class TestNSCell(TestCase):
    def testUnicode(self):
        u = u'\xc3\xbc\xc3\xb1\xc3\xae\xc3\xa7\xc3\xb8d\xc3\xa8'
        cell = NSCell.alloc().initTextCell_(u)
        cell.setStringValue_(u)
        self.assertEquals(cell.stringValue(), u)

    def testInt(self):
        i = 17
        cell = NSCell.alloc().initTextCell_(u"")
        cell.setIntValue_(i)
        self.assertEquals(cell.intValue(), i)

    def testFloat(self):
        f = 3.125
        cell = NSCell.alloc().initTextCell_(u"")
        cell.setFloatValue_(f)
        self.assertEquals(cell.floatValue(), f)

    def testMethods(self):
        self.failUnlessResultIsBOOL(NSCell.prefersTrackingUntilMouseUp)
        self.failUnlessResultIsBOOL(NSCell.isOpaque)
        self.failUnlessResultIsBOOL(NSCell.isEnabled)
        self.failUnlessArgIsBOOL(NSCell.setEnabled_, 0)
        self.failUnlessResultIsBOOL(NSCell.isContinuous)
        self.failUnlessArgIsBOOL(NSCell.setContinuous_, 0)
        self.failUnlessResultIsBOOL(NSCell.isEditable)
        self.failUnlessArgIsBOOL(NSCell.setEditable_, 0)
        self.failUnlessResultIsBOOL(NSCell.isSelectable)
        self.failUnlessArgIsBOOL(NSCell.setSelectable_, 0)
        self.failUnlessResultIsBOOL(NSCell.isBordered)
        self.failUnlessArgIsBOOL(NSCell.setBordered_, 0)
        self.failUnlessResultIsBOOL(NSCell.isBezeled)
        self.failUnlessArgIsBOOL(NSCell.setBezeled_, 0)
        self.failUnlessResultIsBOOL(NSCell.isScrollable)
        self.failUnlessArgIsBOOL(NSCell.setScrollable_, 0)
        self.failUnlessResultIsBOOL(NSCell.isHighlighted)
        self.failUnlessArgIsBOOL(NSCell.setHighlighted_, 0)
        self.failUnlessResultIsBOOL(NSCell.wraps)
        self.failUnlessArgIsBOOL(NSCell.setWraps_, 0)
        self.failUnlessResultIsBOOL(NSCell.isEntryAcceptable_)
        self.failUnlessArgIsBOOL(NSCell.setFloatingPointFormat_left_right_, 0)
        self.failUnlessResultIsBOOL(NSCell.hasValidObjectValue)
        self.failUnlessArgIsBOOL(NSCell.highlight_withFrame_inView_, 0)
        self.failUnlessArgIsOut(NSCell.getPeriodicDelay_interval_, 0)
        self.failUnlessArgIsOut(NSCell.getPeriodicDelay_interval_, 1)
        self.failUnlessResultIsBOOL(NSCell.startTrackingAt_inView_)
        self.failUnlessResultIsBOOL(NSCell.continueTracking_at_inView_)
        self.failUnlessArgIsBOOL(NSCell.stopTracking_at_inView_mouseIsUp_, 3)
        self.failUnlessResultIsBOOL(NSCell.trackMouse_inRect_ofView_untilMouseUp_)
        self.failUnlessArgIsBOOL(NSCell.trackMouse_inRect_ofView_untilMouseUp_, 3)
        self.failUnlessResultIsBOOL(NSCell.sendsActionOnEndEditing)
        self.failUnlessArgIsBOOL(NSCell.setSendsActionOnEndEditing_, 0)
        self.failUnlessResultIsBOOL(NSCell.allowsUndo)
        self.failUnlessArgIsBOOL(NSCell.setAllowsUndo_, 0)
        self.failUnlessResultIsBOOL(NSCell.truncatesLastVisibleLine)
        self.failUnlessArgIsBOOL(NSCell.setTruncatesLastVisibleLine_, 0)
        self.failUnlessResultIsBOOL(NSCell.refusesFirstResponder)
        self.failUnlessArgIsBOOL(NSCell.setRefusesFirstResponder_, 0)
        self.failUnlessResultIsBOOL(NSCell.showsFirstResponder)
        self.failUnlessArgIsBOOL(NSCell.setShowsFirstResponder_, 0)
        self.failUnlessResultIsBOOL(NSCell.wantsNotificationForMarkedText)
        self.failUnlessResultIsBOOL(NSCell.allowsEditingTextAttributes)
        self.failUnlessArgIsBOOL(NSCell.setAllowsEditingTextAttributes_, 0)
        self.failUnlessResultIsBOOL(NSCell.importsGraphics)
        self.failUnlessArgIsBOOL(NSCell.setImportsGraphics_, 0)
        self.failUnlessResultIsBOOL(NSCell.allowsMixedState)
        self.failUnlessArgIsBOOL(NSCell.setAllowsMixedState_, 0)


    def testFunctions(self):
        self.failUnlessArgIsBOOL(NSDrawThreePartImage, 4)
        self.failUnlessArgIsBOOL(NSDrawThreePartImage, 7)
        self.failUnlessArgIsBOOL(NSDrawNinePartImage, 12)

    def testConstants(self):
        self.failUnlessIsInstance(NSControlTintDidChangeNotification, unicode)

        self.failUnlessEqual(NSAnyType, 0)
        self.failUnlessEqual(NSIntType, 1)
        self.failUnlessEqual(NSPositiveIntType, 2)
        self.failUnlessEqual(NSFloatType, 3)
        self.failUnlessEqual(NSPositiveFloatType, 4)
        self.failUnlessEqual(NSDoubleType, 6)
        self.failUnlessEqual(NSPositiveDoubleType, 7)
        self.failUnlessEqual(NSNullCellType, 0)
        self.failUnlessEqual(NSTextCellType, 1)
        self.failUnlessEqual(NSImageCellType, 2)
        self.failUnlessEqual(NSCellDisabled, 0)
        self.failUnlessEqual(NSCellState, 1)
        self.failUnlessEqual(NSPushInCell, 2)
        self.failUnlessEqual(NSCellEditable, 3)
        self.failUnlessEqual(NSChangeGrayCell, 4)
        self.failUnlessEqual(NSCellHighlighted, 5)
        self.failUnlessEqual(NSCellLightsByContents, 6)
        self.failUnlessEqual(NSCellLightsByGray, 7)
        self.failUnlessEqual(NSChangeBackgroundCell, 8)
        self.failUnlessEqual(NSCellLightsByBackground, 9)
        self.failUnlessEqual(NSCellIsBordered, 10)
        self.failUnlessEqual(NSCellHasOverlappingImage, 11)
        self.failUnlessEqual(NSCellHasImageHorizontal, 12)
        self.failUnlessEqual(NSCellHasImageOnLeftOrBottom, 13)
        self.failUnlessEqual(NSCellChangesContents, 14)
        self.failUnlessEqual(NSCellIsInsetButton, 15)
        self.failUnlessEqual(NSCellAllowsMixedState, 16)
        self.failUnlessEqual(NSNoImage, 0)
        self.failUnlessEqual(NSImageOnly, 1)
        self.failUnlessEqual(NSImageLeft, 2)
        self.failUnlessEqual(NSImageRight, 3)
        self.failUnlessEqual(NSImageBelow, 4)
        self.failUnlessEqual(NSImageAbove, 5)
        self.failUnlessEqual(NSImageOverlaps, 6)
        self.failUnlessEqual(NSScaleProportionally, 0)
        self.failUnlessEqual(NSScaleToFit, 1)
        self.failUnlessEqual(NSScaleNone, 2)
        self.failUnlessEqual(NSImageScaleProportionallyDown, 0)
        self.failUnlessEqual(NSImageScaleAxesIndependently,1)
        self.failUnlessEqual(NSImageScaleNone, 2)
        self.failUnlessEqual(NSImageScaleProportionallyUpOrDown, 3)
        self.failUnlessEqual(NSMixedState, -1)
        self.failUnlessEqual(NSOffState,  0)
        self.failUnlessEqual(NSOnState,  1)
        self.failUnlessEqual(NSNoCellMask, 0)
        self.failUnlessEqual(NSContentsCellMask, 1)
        self.failUnlessEqual(NSPushInCellMask, 2)
        self.failUnlessEqual(NSChangeGrayCellMask, 4)
        self.failUnlessEqual(NSChangeBackgroundCellMask, 8)
        self.failUnlessEqual(NSDefaultControlTint, 0)
        self.failUnlessEqual(NSBlueControlTint, 1)
        self.failUnlessEqual(NSGraphiteControlTint, 6)
        self.failUnlessEqual(NSClearControlTint, 7)
        self.failUnlessEqual(NSRegularControlSize, 0)
        self.failUnlessEqual(NSSmallControlSize, 1)
        self.failUnlessEqual(NSMiniControlSize, 2)
        self.failUnlessEqual(NSCellHitNone, 0)
        self.failUnlessEqual(NSCellHitContentArea, 1 << 0)
        self.failUnlessEqual(NSCellHitEditableTextArea, 1 << 1)
        self.failUnlessEqual(NSCellHitTrackableArea, 1 << 2)
        self.failUnlessEqual(NSBackgroundStyleLight, 0)
        self.failUnlessEqual(NSBackgroundStyleDark, 1)
        self.failUnlessEqual(NSBackgroundStyleRaised, 2)
        self.failUnlessEqual(NSBackgroundStyleLowered, 3)
    
    @min_os_level('10.6')
    def testMethods10_6(self):
        self.failUnlessResultIsBOOL(NSCell.usesSingleLineMode)
        self.failUnlessArgIsBOOL(NSCell.setUsesSingleLineMode_, 0)


if __name__ == '__main__':
    main( )
